Plugin.extend({
    _type: 'sorts',
    _isContainer: false,
    _render: false,
    _index: -1,
    _model: undefined,
    _value: undefined,
    _answer: undefined,
    _multiple: false,
    _mapedTo: undefined,
    _uniqueId: undefined,
    _droppedRhsArr: undefined,
    initPlugin: function(data) {
        this._model = undefined;
        this._value = undefined;
        this._answer = undefined;
        this._index = -1;
        this._uniqueId = _.uniqueId('opt_');
        console.log(data);
        var custEvalInst = new CustomEval();
        EkstepRendererAPI.registerEval("mtf", custEvalInst);

        if (!_.isUndefined(data.droppedRhsArr)) {
            this._droppedRhsArr = data.droppedRhsArr;
        }

        var model = data.option;
        var value = undefined;

        if (data.multiple)
            this._multiple = data.multiple;

        if (this._parent._controller && model) {
            this._model = model;
            var controller = this._parent._controller;
            value = controller.getModelValue(model);
            this._index = parseInt(model.substring(model.indexOf('[') + 1, model.length - 1));
            var varName = (this._data['var'] ? this._data['var'] : 'option');
            this._stage._templateVars[varName] = this._parent._data.model + "." + model;
            var modelValue = this._stage.getModelValue(this._parent._data.model + '.' + model);
        }
        if (value && _.isFinite(this._index) && this._index > -1) {
            this._self = new createjs.Container();
            var dims = this.relativeDims();
            this._self.x = dims.x;
            this._self.y = dims.y;
            this._self.origX = dims.x;
            this._self.origY = dims.y;
            this._self.width = dims.w;
            this._self.height = dims.h;
            var hit = new createjs.Shape();
            hit.graphics.beginFill("#000").r(0, 0, dims.w, dims.h);
            this._self.hitArea = hit;
            this._value = value.value;
            this.setOptionIndex(data);
            this.initShadow(data);
            var innerECML = this.getInnerECML();
            if (!_.isEmpty(innerECML)) {
                this.renderInnerECML();
            } else if (value.value.type == 'image') {
                this.renderImage(value.value);
            } else if (value.value.type == 'text') {
                this.renderText(value.value);
            }

            /*if (this._parent._type == 'mcq') {
                this.renderMCQOption();
            } else*/
            if (this._parent._type == 'mtf') {
                this.renderMTFOption(value);
            }
            this.resolveModelValue(this._data);
            this._render = true;
        }
    },

    renderMTFOption: function(value) {
        console.log(value);
        var enableDrag = false;
        var dragPos = {};
        var dragItem = {};
        var controller = this._parent._controller;
        var itemId = controller.getModelValue("identifier");

        if (_.isFinite(value.index)) {
            this._index = value.index;
            this._parent._lhs_options.push(this);
        } else {
            this._parent._rhs_options.push(this);
            enableDrag = true;
            console.log(this._parent._rhs_options);
        }
        if (enableDrag) {
            var instance = this;
            var asset = this._self;
            asset.cursor = 'pointer';

            asset.on("mousedown", function(evt) {
                this.parent.addChild(this);
                this.offset = {
                    x: this.x - evt.stageX,
                    y: this.y - evt.stageY
                };
                dragItem = instance._value.resvalue;
                dragPos = {
                    x: evt.stageX,
                    y: evt.stageY
                };
                var data = {
                    type: evt.type,
                    x: evt.stageX,
                    y: evt.stageY,
                    drag_id: instance._value.resvalue,
                    itemId: itemId
                }

            });
            asset.on("pressmove", function(evt) {
                this.x = evt.stageX + this.offset.x;
                this.y = evt.stageY + this.offset.y;

                instance.addShadow();

                Renderer.update = true;
            });
            asset.on("pressup", function(evt) {
                var snapTo;
                if (instance._parent._force === true) {
                    snapTo = instance._parent.getLhsOption(value.answer);
                } else {
                    snapTo = instance._parent._lhs_options;
                }
                var rhsHeight = 2.5 * instance._parent._rhs_options[0]._data.h;
                var plugin;
                var dims;
                var lhsPlugin;
                var snapSuccess = false;
                if (_.isArray(snapTo)) {
                    for (var i = 0; i < snapTo.length; i++) {
                        if (snapSuccess) {
                            break;
                        } else {
                            plugin = snapTo[i];
                            dims = plugin._dimensions;
                            var xFactor = parseFloat(this.width * (50 / 100));
                            var yFactor = parseFloat(this.height * (50 / 100));
                            var x = dims.x - xFactor,
                                y = dims.y - yFactor,
                                maxX = dims.x + dims.w + xFactor,
                                maxY = dims.y + dims.h + yFactor;
                            if (this.x >= x && (this.x + this.width) <= maxX) {
                                if (this.y >= y && (this.y + this.height) <= maxY) {
                                    if (plugin._droppedRhsArr.length < 5) {
                                        this._mapedTo = snapTo[i];
                                        lhsPlugin = snapTo[i];
                                        snapSuccess = true;
                                    } else {
                                        snapSuccess = false;
                                    }
                                }
                            }
                        }
                    }
                } else if (snapTo) {
                    plugin = snapTo;
                    dims = plugin._dimensions;
                    var xFactor = parseFloat(this.width * (50 / 100));
                    var yFactor = parseFloat(this.height * (50 / 100));
                    var x = dims.x - xFactor,
                        y = dims.y - yFactor,
                        maxX = dims.x + dims.w + xFactor,
                        maxY = dims.y + dims.h + yFactor;
                    if (this.x >= x && (this.x + this.width) <= maxX) {
                        if (this.y >= y && (this.y + this.height) <= maxY) {
                            snapSuccess = true;
                        }
                    }
                }

                var drop_id = (snapSuccess ? plugin._id : '');
                var drop_idx = (snapSuccess ? plugin._index : '');
                var drop_rsv = (snapSuccess ? plugin._value.resvalue : '');
                var drag_rsv = instance._value.resvalue;
                var rhsOptions = instance._parent._rhs_options;
                if (!snapSuccess) {
                    if (_.isUndefined(lhsPlugin)) {
                        lhsPlugin = this._mapedTo;
                    }
                    if (!_.isUndefined(lhsPlugin) && lhsPlugin._droppedRhsArr.length > 0) {
                        lhsPlugin._droppedRhsArr = _.reject(lhsPlugin._droppedRhsArr, function(obj) {
                            return obj.resindex == instance._value.resindex;
                        });
                        _.each(lhsPlugin._droppedRhsArr, function(opt, i) {
                            _.each(rhsOptions, function(option, j) {
                                if (opt.index == option._index) {
                                    option._self.y = dims.y + (dims.h * (lhsPlugin._data.snapY / 100)) + (rhsHeight * i);
                                    opt.y = option._self.y;

                                }
                            });
                        });

                    }
                    this.x = this.origX;
                    this.y = this.origY;
                    if (_.isArray(snapTo)) {
                        for (var i = 0; i < snapTo.length; i++) {
                            var lhsQues = snapTo[i];
                            if (lhsQues._answer) {
                                if (lhsQues._answer._uniqueId == instance._uniqueId) {
                                    lhsQues._answer = undefined;
                                    instance._parent.setAnswerMapping(instance, undefined);
                                    break;
                                }
                            }
                        }
                    }
                } else {
                    var flag = true;
                    // If multiple attribute of sorting tag is true.
                    if (plugin._multiple)
                        flag = false;
                    // If there is an existing answer, nudge it out
                    if (plugin._answer && flag) {
                        var existing = plugin._answer;
                        existing._parent.setAnswerMapping(existing, undefined);

                        existing._self.x = existing._self.origX;
                        existing._self.y = existing._self.origY;
                    }

                    // Set the current answer as accepted
                    if (!_.isUndefined(plugin._data.snapX)) {
                        if (instance._parent._lhs_options.length === 3) {
                            this.x = dims.x + (dims.w * plugin._data.snapX / 100) + dims.w / 8;
                        } else if (instance._parent._lhs_options.length === 2) {
                            this.x = dims.x + (dims.w * plugin._data.snapX / 100) + dims.w / 6;
                        } else
                            this.x = dims.x + (dims.w * plugin._data.snapX / 100);
                    }
                    if (!_.isUndefined(plugin._data.snapY)) {
                        if (plugin._multiple) {
                            var totalElements = lhsPlugin._droppedRhsArr.length;
                            var lhsOptions = instance._parent._lhs_options;
                            var isPresent = _.contains(lhsPlugin._droppedRhsArr, instance._value);
                            if (!isPresent) {
                                _.each(instance._parent._lhs_options, function(obj) {
                                    var isMatched = false;
                                    isMatched = _.contains(obj._droppedRhsArr, instance._value);
                                    obj._droppedRhsArr = _.reject(obj._droppedRhsArr, function(o) {
                                        return o.resindex == instance._value.resindex;
                                    });
                                    if (isMatched) {
                                        _.each(obj._droppedRhsArr, function(opt, i) {
                                            _.each(rhsOptions, function(option, j) {
                                                if (opt.index == option._index) {
                                                    option._self.y = dims.y + (dims.h * (obj._data.snapY / 100)) + (rhsHeight * i);
                                                    opt.y = option._self.y;
                                                }
                                            });
                                        });
                                    }
                                });
                            }


                            if (totalElements > 0) {
                                if (isPresent) {
                                    this.y = instance._value.y;
                                } else {
                                    _.each(lhsPlugin._droppedRhsArr, function(opt, i) {
                                        _.each(rhsOptions, function(option, j) {
                                            if (opt.index == option._index) {
                                                option._self.y = dims.y + (dims.h * (lhsPlugin._data.snapY / 100)) + (rhsHeight * i);
                                                opt.y = option._self.y;
                                            }
                                        });
                                    });
                                    var newY = dims.y + (dims.h * (lhsPlugin._data.snapY / 100)) + (rhsHeight * totalElements);
                                    this.y = newY;
                                    instance._value.y = newY;
                                    instance._value.index = instance._index;
                                    lhsPlugin._droppedRhsArr.push(instance._value);

                                }
                            } else {
                                this.y = dims.y + (dims.h * (lhsPlugin._data.snapY / 100));
                                instance._value.y = this.y;
                                instance._value.index = instance._index;
                                lhsPlugin._droppedRhsArr.push(instance._value);
                            }
                        } else
                            this.y = dims.y + (dims.h * (lhsPlugin._data.snapY / 100));
                    }

                    instance._parent.setAnswerMapping(instance, plugin);


                    // Remember the answer so that on overwrite, we can clear it
                    if (_.isArray(snapTo)) {
                        for (var i = 0; i < snapTo.length; i++) {
                            var rhsOption = snapTo[i];
                            if (rhsOption._answer == instance)
                                rhsOption._answer = undefined;
                        }
                    } else if (snapTo) {
                        if (snapTo._answer == instance)
                            snapTo._answer = undefined;
                    }
                    plugin._answer = instance;
                }
                OverlayManager.handleSubmit();
                if (!(("undefined" != typeof drop_idx) && ("" !== drop_idx))) {
                    instance._parent.setAnswerMapping(instance, undefined);
                }

                instance.removeShadow();

                var data = {
                    type: evt.type,
                    x: evt.stageX,
                    y: evt.stageY,
                    choice_id: instance._value.resindex,
                    itemId: itemId,
                    drop_id: drop_id,
                    drop_idx: drop_idx,
                    pos: [{ x: evt.stageX, y: evt.stageY }, dragPos],
                    res: [{
                        "rhs": drag_rsv
                    }, {
                        "lhs": drop_rsv
                    }],
                    state: (("undefined" != typeof drop_idx) && ("" !== drop_idx)) ? "SELECTED" : "UNSELECTED",
                    optionTag: "MTF"
                }


                Renderer.update = true;
            });
        }
    },
    renderImage: function(value) {
        var data = {};
        data.asset = value.asset;
        var padx = this._data.padX || 0;
        var pady = this._data.padY || 0;
        data.x = padx;
        data.y = pady;
        data.w = 100 - (2 * padx);
        data.h = 100 - (2 * pady);

        if (value.count) {
            data.count = value.count;
            data.type = "gridLayout";
            PluginManager.invoke('placeholder', data, this, this._stage, this._theme);
        } else {
            PluginManager.invoke('image', data, this, this._stage, this._theme);
        }

        this._data.asset = value.asset;
    },
    renderText: function(data) {
        data.$t = data.asset;
        var padx = this._data.padX || 0;
        var pady = this._data.padY || 0;
        data.x = padx;
        data.y = pady;
        data.w = 100 - (2 * padx);
        data.h = 100 - (2 * pady);
        data.fontsize = (data.fontsize) ? data.fontsize : 200;
        var align = (this._data.align ? this._data.align.toLowerCase() : 'center');
        var valign = (this._data.valign ? this._data.valign.toLowerCase() : 'middle');

        data.align = align;
        data.valign = valign;

        PluginManager.invoke('text', data, this, this._stage, this._theme);
        this._data.asset = data.asset;
    },
    initShadow: function(data) {

        var highlightColor = this._data.highlight || '#E89241';
        var shadowColor = this._data.shadowColor || '#cccccc';
        var shadowData = {
            x: 0,
            y: 0,
            w: 100,
            h: 100,
            type: 'roundrect',
            fill: highlightColor,
            visible: false,
            opacity: (this._data.opacity || 1)
        };
        this._self.shadow = PluginManager.invoke('shape', shadowData, this, this._stage, this._theme);

        var offsetX = this._data.offsetX || 0;
        var offsetY = this._data.offsetY || 0;
        var blur = this._data.blur || 2;
        this._self.shadow._self.shadow = new createjs.Shadow(shadowColor, offsetX, offsetY, blur);
    },
    setOptionIndex: function(data) {
        data = JSON.stringify(data);
        data = data.replace(new RegExp('\\$current', 'g'), this._index);
        data = JSON.parse(data);
        this._data = data;
    },
    renderInnerECML: function() {
        var innerECML = this.getInnerECML();
        if (!_.isEmpty(innerECML)) {
            var data = {};
            var padx = this._data.padX || 0;
            var pady = this._data.padY || 0;
            data.x = padx;
            data.y = pady;
            data.w = 100 - (2 * padx);
            data.h = 100 - (2 * pady);
            Object.assign(data, innerECML);
            PluginManager.invoke('g', data, this, this._stage, this._theme);
        }
    },
    resolveModelValue: function(data) {
        var instance = this;
        var updateAction = function(action) {
            if (action.asset_model) {
                var model = action.asset_model;
                var val = instance._stage.getModelValue(model);
                action.asset = val;
                delete action.asset_model;
            }
        }
        var updateEvent = function(evt) {
            if (_.isArray(evt.action)) {
                evt.action.forEach(function(action) {
                    updateAction(action);
                });
            } else if (evt.action) {
                updateAction(evt.action);
            }
        }
        var events = undefined;
        if (data.events) {
            if (_.isArray(data.events)) {
                events = [];
                data.events.forEach(function(e) {
                    events.push.apply(events, e.event);
                });
            } else {
                events = data.events.event
            }
        } else {
            events = data.event;
        }
        if (_.isArray(events)) {
            events.forEach(function(e) {
                updateEvent(e);
            });
        } else if (events) {
            updateEvent(events);
        }
    }
});


var CustomEval = IEvaluator.extend({
    evaluate: function (item) {
        var result = {};
        var pass = true;
        var score = 0;
        var res = [];

        if (item) {
            var options = item.rhs_options;
            var rhsSelected = [];
            if (_.isArray(options)) {
                _.each(options, function (opt) {
                    // Generate telemetry if there was a response to this option (rhs -> lhs)
                    if (typeof opt.selected != 'undefined') {
                        var obj = {};
                        obj[opt.value.resvalue] = opt.value.mapped;
                        res.push(obj);
                    }

                    // Answer is specified and correctly matched
                    if (Number.isInteger(opt.answer)) {
                        rhsSelected.push(opt);
                        if (opt.answer == opt.selected) {
                            score = 1;
                        }
                    } else {
                        // Answer is not specified, but still matched (distractor)
                        if (typeof opt.selected != 'undefined') {
                            pass = false;
                        }
                    }
                });
            }

            if (pass) {
                var ansMatched = _.isEqual(_.pluck(rhsSelected, "selected"), _.pluck(rhsSelected, "answer"));
                pass = ansMatched;
                rhsSelected = [];
            }

            if (!pass) {
                result.feedback = item.feedback;
                if (!item.partial_scoring) {
                    score = 0;
                }
            }
        }

        result.pass = pass;
        result.score = score;
        result.res = res;

        return result;
    }
});
//# sourceURL=sort.js